psql postgres -c "DROP TABLE foo;"
psql postgres -c "CREATE TABLE foo (data text);"

# 10 tuples, fits in one page

psql postgres -c "TRUNCATE foo; INSERT INTO foo SELECT (repeat('a', 300)) FROM generate_series(1, 10); DELETE FROM foo WHERE ctid < (SELECT max(ctid) FROM foo);"
psql postgres -c "VACUUM foo;"
pgbench -n -f fsmbench.sql postgres -t 100 -c 1

# 1000, ~36 pages

psql postgres -c "TRUNCATE foo; INSERT INTO foo SELECT (repeat('a', 300)) FROM generate_series(1, 1000); DELETE FROM foo WHERE ctid < (SELECT max(ctid) FROM foo);"
psql postgres -c "VACUUM foo;"
psql postgres -c "SELECT pg_size_pretty(pg_relation_size('foo'))"
pgbench -n -f fsmbench.sql postgres -t 100 -c 1

# 10000, ~360 pages, still fits in one FSM page

psql postgres -c "TRUNCATE foo; INSERT INTO foo SELECT (repeat('a', 300)) FROM generate_series(1, 10000); DELETE FROM foo WHERE ctid < (SELECT max(ctid) FROM foo);"
psql postgres -c "VACUUM foo;"
psql postgres -c "SELECT pg_size_pretty(pg_relation_size('foo'))"
pgbench -n -f fsmbench.sql postgres -t 100 -c 1

# 100000, ~3600 pages, still fits in one FSM page

psql postgres -c "TRUNCATE foo; INSERT INTO foo SELECT (repeat('a', 300)) FROM generate_series(1, 100000); DELETE FROM foo WHERE ctid < (SELECT max(ctid) FROM foo);"
psql postgres -c "VACUUM foo;"
psql postgres -c "SELECT pg_size_pretty(pg_relation_size('foo'))"
pgbench -n -f fsmbench.sql postgres -t 100 -c 1

# 1000000, ~36000 pages, Doesn't fit in one FSM page anymore

psql postgres -c "TRUNCATE foo; INSERT INTO foo SELECT (repeat('a', 300)) FROM generate_series(1, 1000000); DELETE FROM foo WHERE ctid < (SELECT max(ctid) FROM foo);"
psql postgres -c "VACUUM foo;"
psql postgres -c "SELECT pg_size_pretty(pg_relation_size('foo'))"
pgbench -n -f fsmbench.sql postgres -t 10 -c 1

# 10000000, ~360000 pages, Doesn't fit in one FSM page anymore
psql postgres -c "TRUNCATE foo; INSERT INTO foo SELECT (repeat('a', 300)) FROM generate_series(1, 10000000); DELETE FROM foo WHERE ctid < (SELECT max(ctid) FROM foo);"
psql postgres -c "VACUUM foo;"
psql postgres -c "SELECT pg_size_pretty(pg_relation_size('foo'))"
pgbench -n -f fsmbench.sql postgres -t 10 -c 1

